Description

When manipulating text files, mostly, the input record separator(saying "\n") is scrap and will be chomped.

I suggest a method IO#each_chomped directly yielding the record with input record separator chomped.

Laziness is a virtue..

Joey

History

#1 - 05/25/2011 11:11 PM - rosenfeld (Rodrigo Rosenfeld Rosas)

I wouldn't say this is about laziness, but about code readability. I agree this is a common use, but doesn't each_line already do that?

#2 - 05/25/2011 11:43 PM - yimutang (Joey Zhou)

Rodrigo Rosenfeld Rosas wrote:

I wouldn't say this is about laziness, but about code readability. I agree this is a common use, but doesn't each_line already do that?

 No, #each_line is just a synonym of #each.

#3 - 05/26/2011 12:05 AM - rosenfeld (Rodrigo Rosenfeld Rosas)

Yes, I was confused by the fact that puts already chomps the argument...

#4 - 06/03/2011 09:22 AM - naruse (Yui NARUSE)

- Status changed from Open to Assigned

- Assignee set to matz (Yukihiro Matsumoto)

#5 - 06/08/2011 05:08 PM - headius (Charles Nutter)

Trivial Ruby impl...

class IO

def each_chomped

each {|x| yield x.chomp!}

end

end

Of course if you don't mind the whole file being read into memory:

io.each.map(&:chomp).each { ...

Might be a way to pipeline that without reading into memory.

#6 - 06/09/2011 12:54 AM - josb (Jos Backus)

Charles, shouldn't

x.chomp!

be

x.chomp

in the above code? x.chomp! can return nil.
#7 - 06/09/2011 06:53 AM - headius (Charles Nutter)

Yeah, probably...or it should be x.chomp!; yield x

My intent was to avoid creating a useless transient object.

Charlie (mobile)

On Jun 8, 2011, at 10:54, Jos Backus jos@catnook.com wrote:

Issue #4778 has been updated by Jos Backus.

Charles, shouldn't

x.chomp!

be

x.chomp

in the above code? x.chomp! can return nil.
#8 - 07/01/2012 07:32 AM - Eregon (Benoit Daloze)

- File feature4778.pdf added

Attached one-minute slide for this proposal.

I think the name might still be matter of discussion (it could maybe even be an option of #each_line), but it would be interesting to get the general idea

evaluated.

#9 - 07/02/2012 02:38 AM - mame (Yusuke Endoh)

Received, thank you!

I missed (or forgot) this feature request, but I love it.

Thank you putting this in the spotlight!

--

Yusuke Endoh mame@tsg.ne.jp

#10 - 07/02/2012 03:15 AM - trans (Thomas Sawyer)

How about just each_chomp(str="\n") ?

#11 - 07/23/2012 11:25 PM - mame (Yusuke Endoh)

- Status changed from Assigned to Rejected

Benoit Daloze,

Sorry but this proposal was rejected at the developer meeting (7/21).
Both feature itself and name are not so bad.

But the reason it was rejected is fear of endless similar proposals.

So, please start it as a gem.

Matz might reconsider it if your gem really becomes widely used.

--

Yusuke Endoh mame@tsg.ne.jp
